 //
// SourceMod Script
//
// Developed by Misery
// MAY 2009
// http://thelw.forum-actif.net
//
// DESCRIPTION :
// For Day of Defeat Source only
// This plugin is a UNLIMITED FRAG GRENADES MOD
//
// Only TRAIN with frag admin enable
// Only CURRENT GAME with frag admin disable (choose a reasonable number of grenades to play)
//
// CHANGELOG :
// - 26.05.2009 Version 1.0.1
// - Add NoClip for admins
//

#include <sourcemod>
#include <sdktools>

#define PLUGIN_VERSION "1.0.1"

public Plugin:myinfo = 
{
	name = "UNLIMITED FRAG MOD", 
	author = "Misery", 
	description = "Mod UNLIMITED FRAG GRENADES", 
	version = PLUGIN_VERSION, 
	url = "http://thelw.forum-actif.net"
};

new Handle:uf_Frag_Enable
new Handle:uf_Frag_Admin_Enable
new Handle:uf_Frag_Grenades
new Handle:uf_Frag_Bazooka
new Handle:uf_Rifle_Grenades
new Handle:uf_Movement_Player
new Handle:uf_Curent_Game_Enable

new String:uf_Weapon_Frag_Grenade[4][] =  { "", "", "weapon_frag_us", "weapon_frag_ger" }
new String:uf_Weapon_Rifle_Grenade[4][] =  { "", "", "weapon_riflegren_us", "weapon_riflegren_ger" }
new String:uf_Weapon_Bazooka[4][] =  { "", "", "bazooka", "pschreck" }

new uf_Frag_Grenade_Offset[4] =  { 0, 0, 52, 56 }
new uf_Rifle_Grenade_Offset[4] =  { 0, 0, 84, 88 }
new uf_Bazooka_Offset[4] =  { 0, 0, 44, 48 }

new Handle:uf_InfoMod[MAXPLAYERS + 1]

new bool:uf_SpeedPlayer[64]
new bool:uf_NoClipPlayer[64]
new uf_maxClients

public OnPluginStart()
{
	CreateConVar("sm_dod_unlimited_grenades_version", PLUGIN_VERSION, "unlimited grenades Version", FCVAR_PLUGIN | FCVAR_SPONLY | FCVAR_REPLICATED | FCVAR_NOTIFY)
	
	RegConsoleCmd("sm_frag", Command_Frag, "DoD:S TRAIN Frag.", ADMFLAG_BAN)
	RegConsoleCmd("sm_speed", Command_Speed, "DoD:S TRAIN Speed.", ADMFLAG_BAN)
	RegAdminCmd("sm_noclip", Command_NoClip, ADMFLAG_SLAY | ADMFLAG_CHEATS, "sm_noclip <#userid|name>")
	
	uf_Frag_Enable = CreateConVar("sm_dod_frag_enable", "1", "Enable/disable DoD:S Unlimited Grenades", FCVAR_PLUGIN)
	uf_Frag_Admin_Enable = CreateConVar("sm_dod_frag_admin_enable", "0", "Only admins can have grenades and more... 1/0", FCVAR_PLUGIN)
	uf_Frag_Grenades = CreateConVar("sm_dod_frag_grenades_count", "20", "Set number of Frag grenades - Mini 1", FCVAR_PLUGIN)
	uf_Rifle_Grenades = CreateConVar("sm_dod_Rifle_grenades_count", "20", "Set number of Rifle grenades - Mini 1", FCVAR_PLUGIN)
	uf_Frag_Bazooka = CreateConVar("sm_dod_Bazooka_grenades_count", "20", "Set number of Frag bazooka - Mini 1", FCVAR_PLUGIN)
	uf_Curent_Game_Enable = CreateConVar("sm_dod_Curent_Game_Enable", "0", "Set speed and reload of players with the command !speed and !frag in current game - 1: Normaly speed and no reload grenades - 0: Speed player and can reload grenades", FCVAR_PLUGIN)
	uf_Movement_Player = CreateConVar("sm_dod_movement_Player", "1.5", "Set speed of players with the command !speed", FCVAR_PLUGIN)
	
	HookEvent("player_spawn", PlayerSpawnEvent)
	
	PrintToServer("----------------|         SM_Unlimited_Grenades Loaded         |---------------")
}

public OnClientPutInServer(client)
{
	if ((client == 0) || !IsClientConnected(client))
	{
		return 
	}
	
	uf_InfoMod[client] = CreateTimer(25.0, InfoMod, client, TIMER_FLAG_NO_MAPCHANGE)
}

public PlayerSpawnEvent(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"))
	
	if (client == 0 || !IsClientInGame(client) || !IsPlayerAlive(client) || IsFakeClient(client))
	{
		return 
	}
	
	if (GetConVarInt(uf_Frag_Enable) == 1)
	{
		if (GetConVarInt(uf_Frag_Admin_Enable) == 1)
		{
			if (GetUserAdmin(client) == INVALID_ADMIN_ID)
			{
				return 
			}
		}
		
		if (uf_NoClipPlayer[client] == true)
		{
			SetEntityMoveType(client, MOVETYPE_WALK)
		}
		
		//Reinitialise la vitesse et le NoClip
		uf_SpeedPlayer[client] = false
		uf_NoClipPlayer[client] = false
		
		SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", 1.0)
		
		CreateTimer(0.1, EnableGrenadesOnSpawn, client, TIMER_FLAG_NO_MAPCHANGE)
	}
}

public OnEventShutdown()
{
	UnhookEvent("player_spawn", PlayerSpawnEvent)
}

public Action:Command_Frag(client, args)
{
	if (client == 0 || !IsClientInGame(client) || !IsPlayerAlive(client) || IsFakeClient(client))
	{
		return 
	}
	
	if (GetConVarInt(uf_Frag_Enable) == 1)
	{
		if (GetConVarInt(uf_Frag_Admin_Enable) == 1)
		{
			if (GetUserAdmin(client) == INVALID_ADMIN_ID)
			{
				return 
			}
		}
		
		if (GetConVarInt(uf_Curent_Game_Enable) != 1)
		{
			new team = GetClientTeam(client)
			
			new ammo_offset = FindSendPropOffs("CDODPlayer", "m_iAmmo")
			new fraggrenades = GetConVarInt(uf_Frag_Grenades)
			new fragbazooka = GetConVarInt(uf_Frag_Bazooka)
			new riflegrenades = GetConVarInt(uf_Rifle_Grenades)
			
			GivePlayerItem(client, uf_Weapon_Frag_Grenade[team])
			SetEntData(client, ammo_offset + uf_Frag_Grenade_Offset[team], fraggrenades, 4, true)
			
			GivePlayerItem(client, uf_Weapon_Bazooka[team])
			SetEntData(client, ammo_offset + uf_Bazooka_Offset[team], fragbazooka, 4, true)
			
			GivePlayerItem(client, uf_Weapon_Rifle_Grenade[team])
			SetEntData(client, ammo_offset + uf_Rifle_Grenade_Offset[team], riflegrenades, 4, true)
		}
	}
}

public Action:Command_Speed(client, args)
{
	if (client == 0 || !IsClientInGame(client) || !IsPlayerAlive(client) || IsFakeClient(client))
	{
		return 
	}
	
	if (GetConVarInt(uf_Frag_Enable) == 1)
	{
		if (GetConVarInt(uf_Frag_Admin_Enable) == 1)
		{
			if (GetUserAdmin(client) == INVALID_ADMIN_ID)
			{
				return 
			}
		}
		
		if (GetConVarInt(uf_Curent_Game_Enable) != 1)
		{
			if (uf_SpeedPlayer[client] == true)
			{
				uf_SpeedPlayer[client] = false
				SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", 1.0)
				PrintToChat(client, "\x01Speed: \x04OFF\x01")
			}
			else
			{
				new Float:SpeedPlayers = GetConVarFloat(uf_Movement_Player)
				
				uf_SpeedPlayer[client] = true
				SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", SpeedPlayers)
				PrintToChat(client, "\x01Speed: \x04ON\x01")
			}
		}
	}
}

public Action:Command_NoClip(client, args)
{
	if (client == 0 || !IsClientInGame(client) || IsFakeClient(client))
	{
		return 
	}
	
	if (GetConVarInt(uf_Frag_Enable) == 1)
	{
		if (uf_NoClipPlayer[client] == true)
		{
			uf_NoClipPlayer[client] = false
			SetEntityMoveType(client, MOVETYPE_WALK)
			
			PrintToChat(client, "\x01NoClip: \x04OFF\x01")
		}
		else
		{
			uf_NoClipPlayer[client] = true
			SetEntityMoveType(client, MOVETYPE_NOCLIP)
			
			PrintToChat(client, "\x01NoClip: \x04ON\x01")
		}
	}
}

public Action:EnableGrenadesOnSpawn(Handle:timer, any:client)
{
	if (client == 0 || !IsClientInGame(client) || !IsPlayerAlive(client) || IsFakeClient(client))
	{
		return 
	}
	
	if (GetConVarInt(uf_Frag_Enable) == 1)
	{
		new team = GetClientTeam(client)
		
		new ammo_offset = FindSendPropOffs("CDODPlayer", "m_iAmmo")
		new fraggrenades = GetConVarInt(uf_Frag_Grenades)
		new fragbazooka = GetConVarInt(uf_Frag_Bazooka)
		new riflegrenades = GetConVarInt(uf_Rifle_Grenades)
		
		GivePlayerItem(client, uf_Weapon_Frag_Grenade[team])
		SetEntData(client, ammo_offset + uf_Frag_Grenade_Offset[team], fraggrenades, 4, true)
		
		GivePlayerItem(client, uf_Weapon_Bazooka[team])
		SetEntData(client, ammo_offset + uf_Bazooka_Offset[team], fragbazooka, 4, true)
		
		GivePlayerItem(client, uf_Weapon_Rifle_Grenade[team])
		SetEntData(client, ammo_offset + uf_Rifle_Grenade_Offset[team], riflegrenades, 4, true)
	}
}

public Action:InfoMod(Handle:timer, any:client)
{
	uf_InfoMod[client] = INVALID_HANDLE
	
	if (client == 0 || !IsClientInGame(client) || !IsPlayerAlive(client) || IsFakeClient(client))
	{
		return Plugin_Continue
	}
	
	if (GetConVarInt(uf_Frag_Enable) == 1 && IsClientConnected(client) && IsClientInGame(client) && !IsFakeClient(client))
	{
		new String:message[64]
		
		if (GetConVarInt(uf_Frag_Admin_Enable) == 1)
		{
			if (GetUserAdmin(client) == INVALID_ADMIN_ID)
			{
				return Plugin_Continue
			}
			
			//Thanks to the Developper, let his name please !
			PrintToChat(client, "\x01\x04[UNLIMITED GRENADES]\x01 TRAINING: \x01\x04ON\x01 - Training to grenades")
			PrintToChat(client, "\x01\x04\x01 Developped by Misery")
			
			Format(message, 64, "Nades: !frag - Speed: !speed - NoClip: !noclip")
			SendPanelToAll("TRAINING MOD", message)
		}
		else
		{
			if (GetConVarInt(uf_Curent_Game_Enable) == 1)
			{
				//Thanks to the Developper, let his name please !
				PrintToChat(client, "\x01\x04[BONUS GRENADES]\x01 BONUS: \x01\x04ON\x01")
				PrintToChat(client, "\x01\x04\x01 Developped by Misery")
			}
			else
			{
				if (GetUserAdmin(client) != INVALID_ADMIN_ID)
				{
					//Thanks to the Developper, let his name please !
					PrintToChat(client, "\x01\x04[UNLIMITED GRENADES]\x01 TRAINING: \x01\x04ON\x01 - Training to grenades")
					PrintToChat(client, "\x01\x04\x01 Developped by Misery")
					
					Format(message, 64, "Nades: !frag - Speed: !speed - NoClip: !noclip")
					SendPanelToAll("BONUS", message)
				}
				else
				{
					//Thanks to the Developper, let his name please !
					PrintToChat(client, "\x01\x04[UNLIMITED GRENADES]\x01 TRAINING: \x01\x04ON\x01")
					PrintToChat(client, "\x01\x04\x01 Developped by Misery")
					
					Format(message, 64, "Nades: !frag - Speed: !speed")
					SendPanelToAll("BONUS", message)
				}
			}
		}
	}
	return Plugin_Handled
}

public OnClientDisconnect(client)
{
	if (client != 0)
	{
		if (uf_InfoMod[client] != INVALID_HANDLE)
		{
			CloseHandle(uf_InfoMod[client])
			uf_InfoMod[client] = INVALID_HANDLE
		}
		
		if (uf_NoClipPlayer[client] == true)
		{
			SetEntityMoveType(client, MOVETYPE_WALK)
		}
		
		// Reinitialise les compteurs
		uf_SpeedPlayer[client] = false
		uf_NoClipPlayer[client] = false
	}
}

SendPanelToAll(String:name[], String:message[])
{
	decl String:title[100]
	Format(title, 64, "%s", name)
	
	ReplaceString(message, 192, "\\n", "\n")
	
	new Handle:mSayPanel = CreatePanel()
	SetPanelTitle(mSayPanel, title)
	DrawPanelItem(mSayPanel, "", ITEMDRAW_SPACER)
	DrawPanelText(mSayPanel, message)
	
	SetPanelCurrentKey(mSayPanel, 15)
	
	uf_maxClients = GetMaxClients()
	
	for (new i = 1; i < uf_maxClients; i++)
	{
		if (IsClientInGame(i) && !IsFakeClient(i))
		{
			SendPanelToClient(mSayPanel, i, Handler_DoNothing, 15)
		}
	}
	
	CloseHandle(mSayPanel)
}

public Handler_DoNothing(Handle:menu, MenuAction:action, param1, param2)
{
	/* Do nothing */
} 